//filename: main.cpp

#include <windows.h>
#include <stdlib.h>
#include <wtypes.h>
#include <conio.h>
#include <stdio.h>
#include "resource.h"
#include "main.h"

 
BOOLEAN InitLibFuncs()
{ 
	hLib201 = LoadLibrary ("M201_SP.dll");
    if(!hLib201) return FALSE;

	EX_SendDigout = (P_DLL_EX_SendDigout)GetProcAddress(hLib201, "EX_SendDigout");
	if(!EX_SendDigout) return FALSE;

	EX_GetDigin = (P_DLL_EX_GetDigin)GetProcAddress(hLib201, "EX_GetDigin");
	if(!EX_GetDigin) return FALSE;

	EX_SetPolledModeChan = (P_DLL_EX_SetPolledModeChan)GetProcAddress(hLib201, "EX_SetPolledModeChan");
	if(!EX_SetPolledModeChan) return FALSE;

	EX_GetOneConversion = (P_DLL_EX_GetOneConversion)GetProcAddress(hLib201, "EX_GetOneConversion");
	if(!EX_GetOneConversion) return FALSE;

    return TRUE;
}


int __cdecl main()
{
	if(!InitLibFuncs())
	{ printf("Failed to find required functions"); getch(); return 0;}

	int iKeyChar = 0; char szOutVal[32], szTempBuff[32]; BYTE bDigInput; double dblMilliVolts;  

	BOOLEAN fRedraw = FALSE; char cUserInputVal;
	while(true)
	{
		printf("\nINITIALIZED\nPress one of the following keys:\n"
			"'Q' exit\n"
			"'R' Redraw screen\n"
			"'G' get digital input\n"
			"'S' send digital output (follow by value 255 or less)\n"
			"'V' get one voltage - it will come from preconfigured channel\n"
			"'C' set the channel\n"
			);

		fRedraw = FALSE;
		while((cUserInputVal != 'Q') && (cUserInputVal != 'q') && (cUserInputVal != 27) && (!fRedraw))
		{
			fRedraw = FALSE;
			cUserInputVal = (char)getch();
			switch(cUserInputVal)
			{
				case 'Q': case 'q':
					break;
				case 'R': case 'r':
					fRedraw = TRUE; system("cls"); break;
				case 'G': case 'g':
					if(!EX_GetDigin(&bDigInput)) printf("\nfailed to get digital input\n"); 
					else(printf("\ndigital input: %d\n", bDigInput)); break;
				case 'V': case 'v':
					if(!EX_GetOneConversion(&dblMilliVolts)) printf("\nfailed to get voltage\n"); 
					else(printf("\nvoltage: %2.6lf\n", dblMilliVolts / 1000.0)); break;
				case 'S': case 's':
					sprintf(szOutVal, ""); printf("\nenter value: ");
					while(TRUE)
					{
						iKeyChar = getche(); if(iKeyChar == 13) break;
						sprintf(szTempBuff, "%u", ((BYTE)iKeyChar) - '0');
						strcat(szOutVal, szTempBuff); if(strlen(szOutVal) == 3) break;
					}
					
					if(((UINT)(atoi(szOutVal))) > 255)
					{ printf("\nvalue entered greater than 255. New value: 255"); sprintf(szOutVal, "255"); }
					
					if(!EX_SendDigout((BYTE)(atoi(szOutVal)))) printf("\nfailed to send digital input\n"); 
					else printf("\ndigital output sent: %d\n", (BYTE)(atoi(szOutVal)));
					sprintf(szOutVal, ""); break;
				case 'C': case 'c':
					sprintf(szOutVal, ""); printf("\nenter channel: ");
					while(TRUE)
					{
						iKeyChar = getche(); if(iKeyChar == 13) break;
						sprintf(szTempBuff, "%u", ((BYTE)iKeyChar) - '0');
						strcat(szOutVal, szTempBuff); if(strlen(szOutVal) == 1) break;
					}
					
					if(((UINT)(atoi(szOutVal))) > 7)
					{ printf("\nvalue entered greater than 7. New value: 7"); sprintf(szOutVal, "7"); }
					
					if(!EX_SetPolledModeChan((BYTE)(atoi(szOutVal)), 0)) printf("\nfailed to send channel\n"); 
					else printf("\nchannel sent: %d\n", (BYTE)(atoi(szOutVal)));
					sprintf(szOutVal, ""); break;
			}
		}
		if(!fRedraw) break;
	}
	return 1;
}

